package de.andrena.springbootadvancedtesting.booking;

import java.util.NoSuchElementException;

import org.springframework.cache.annotation.Cacheable;
import org.springframework.stereotype.Service;

import de.andrena.springbootadvancedtesting.swapiclient.StarwarsApiClient;
import de.andrena.springbootadvancedtesting.swapiclient.StarwarsStarship;

@Service
public class StarshipService {
	private StarwarsApiClient starwarsApiClient;

	public StarshipService(StarwarsApiClient starwarsApiClient) {
		this.starwarsApiClient = starwarsApiClient;
	}

	@Cacheable("starship")
	public StarwarsStarship findStarwarsStarship(Starship starshipToRetrieve) {
		return starwarsApiClient
				.findFirst(starship -> starship.getName().equalsIgnoreCase(starshipToRetrieve.getName()))
				.orElseThrow(() -> new NoSuchElementException("Starship not found"));
	}
}
